aboutsummaryrefslogtreecommitdiffstats
path: root/tests
diff options
context:
space:
mode:
authorEddie Hung <eddie@fpgeh.com>2019-11-22 15:38:48 -0800
committerEddie Hung <eddie@fpgeh.com>2019-11-22 15:38:48 -0800
commitbd56161775f47a474aaf5153d2273b86dad4f6f4 (patch)
treef4f8bc875eb0cebec0919e997a73b6b3afc36564 /tests
parent8ef241c6f4a976dca67760c43e820d4e812f2fc2 (diff)
parent450ad0e9ba031fbeef904746ca773e3b0e21af8f (diff)
downloadyosys-bd56161775f47a474aaf5153d2273b86dad4f6f4.tar.gz
yosys-bd56161775f47a474aaf5153d2273b86dad4f6f4.tar.bz2
yosys-bd56161775f47a474aaf5153d2273b86dad4f6f4.zip
Merge branch 'eddie/clkpart' into xaig_dff
Diffstat (limited to 'tests')
-rw-r--r--tests/arch/gowin/mux.ys1
-rwxr-xr-xtests/various/svalways.sh63
2 files changed, 63 insertions, 1 deletions
diff --git a/tests/arch/gowin/mux.ys b/tests/arch/gowin/mux.ys
index 4990be421..afad29a89 100644
--- a/tests/arch/gowin/mux.ys
+++ b/tests/arch/gowin/mux.ys
@@ -45,6 +45,5 @@ design -load postopt # load the post-opt design (otherwise equiv_opt loads the p
cd mux16 # Constrain all select calls below inside the top module
select -assert-count 20 t:IBUF
select -assert-count 1 t:OBUF
-show
select -assert-none t:LUT4 t:MUX2_LUT6 t:MUX2_LUT5 t:MUX2_LUT6 t:MUX2_LUT7 t:MUX2_LUT8 t:IBUF t:OBUF %% t:* %D
diff --git a/tests/various/svalways.sh b/tests/various/svalways.sh
new file mode 100755
index 000000000..2cc09f801
--- /dev/null
+++ b/tests/various/svalways.sh
@@ -0,0 +1,63 @@
+#!/bin/bash
+
+trap 'echo "ERROR in svalways.sh" >&2; exit 1' ERR
+
+# Good case
+../../yosys -f "verilog -sv" -qp proc - <<EOT
+module top(input clk, en, d, output reg p, q, r);
+
+always_ff @(posedge clk)
+ p <= d;
+
+always_comb
+ q = ~d;
+
+always_latch
+ if (en) r = d;
+
+endmodule
+EOT
+
+# Incorrect always_comb syntax
+((../../yosys -f "verilog -sv" -qp proc -|| true) <<EOT
+module top(input d, output reg q);
+
+always_comb @(d)
+ q = ~d;
+
+endmodule
+EOT
+) 2>&1 | grep -F "<stdin>:3: ERROR: syntax error, unexpected '@'" > /dev/null
+
+# Incorrect use of always_comb
+((../../yosys -f "verilog -sv" -qp proc -|| true) <<EOT
+module top(input en, d, output reg q);
+
+always_comb
+ if (en) q = d;
+
+endmodule
+EOT
+) 2>&1 | grep -F "ERROR: Latch inferred for signal \`\\top.\\q' from always_comb process" > /dev/null
+
+# Incorrect use of always_latch
+((../../yosys -f "verilog -sv" -qp proc -|| true) <<EOT
+module top(input en, d, output reg q);
+
+always_latch
+ q = !d;
+
+endmodule
+EOT
+) 2>&1 | grep -F "ERROR: No latch inferred for signal \`\\top.\\q' from always_latch process" > /dev/null
+
+# Incorrect use of always_ff
+((../../yosys -f "verilog -sv" -qp proc -|| true) <<EOT
+module top(input en, d, output reg q);
+
+always_ff @(*)
+ q = !d;
+
+endmodule
+EOT
+) 2>&1 | grep -F "ERROR: Found non edge/level sensitive event in always_ff process" > /dev/null